>From 2373ca7622a7ebb0d53e166dabfb9861c82f0ffd Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Michael=20M=C3=BCller?= <michael@fds-team.de>
Date: Thu, 25 May 2017 07:02:46 +0200
Subject: [PATCH 01/32] kernel32/tests: Add basic tests for fake dlls.

---
 dlls/kernel32/tests/loader.c | 91 ++++++++++++++++++++++++++++++++++++
 1 file changed, 91 insertions(+)

diff --git a/dlls/kernel32/tests/loader.c b/dlls/kernel32/tests/loader.c
index 4bafd0f6349..926fa913866 100644
--- a/dlls/kernel32/tests/loader.c
+++ b/dlls/kernel32/tests/loader.c
@@ -1571,6 +1571,96 @@ static void test_filenames(void)
     DeleteFileA( long_path );
 }
 
+static void test_FakeDLL(void)
+{
+#ifdef __i386__
+    NTSTATUS (WINAPI *pNtSetEvent)(HANDLE, ULONG *) = NULL;
+    IMAGE_EXPORT_DIRECTORY *dir;
+    HMODULE module = GetModuleHandleA("ntdll.dll");
+    HANDLE file, map, event;
+    WCHAR path[MAX_PATH];
+    DWORD *names, *funcs;
+    WORD *ordinals;
+    ULONG size;
+    void *ptr;
+    int i;
+
+    GetModuleFileNameW(module, path, MAX_PATH);
+
+    file = CreateFileW(path, GENERIC_READ | GENERIC_EXECUTE, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, 0);
+    ok(file != INVALID_HANDLE_VALUE, "Failed to open %s (error %u)\n", wine_dbgstr_w(path), GetLastError());
+
+    map = CreateFileMappingW(file, NULL, PAGE_EXECUTE_READ | SEC_IMAGE, 0, 0, NULL);
+    ok(map != NULL, "CreateFileMapping failed with error %u\n", GetLastError());
+    ptr = MapViewOfFile(map, FILE_MAP_READ | FILE_MAP_EXECUTE, 0, 0, 0);
+    ok(ptr != NULL, "MapViewOfFile failed with error %u\n", GetLastError());
+
+    dir = RtlImageDirectoryEntryToData(ptr, TRUE, IMAGE_DIRECTORY_ENTRY_EXPORT, &size);
+todo_wine
+    ok(dir != NULL, "RtlImageDirectoryEntryToData failed\n");
+    if (dir == NULL) goto done;
+
+    names    = RVAToAddr(dir->AddressOfNames, ptr);
+    ordinals = RVAToAddr(dir->AddressOfNameOrdinals, ptr);
+    funcs    = RVAToAddr(dir->AddressOfFunctions, ptr);
+    ok(dir->NumberOfNames > 0, "Could not find any exported functions\n");
+
+    for (i = 0; i < dir->NumberOfNames; i++)
+    {
+        DWORD map_rva, dll_rva, map_offset, dll_offset;
+        char *func_name = RVAToAddr(names[i], ptr);
+        BYTE *dll_func, *map_func;
+
+        /* check only Nt functions for now */
+        if (strncmp(func_name, "Zw", 2) && strncmp(func_name, "Nt", 2))
+            continue;
+
+        dll_func = (BYTE *)GetProcAddress(module, func_name);
+        ok(dll_func != NULL, "%s: GetProcAddress returned NULL\n", func_name);
+        if (dll_func[0] == 0x90 && dll_func[1] == 0x90 &&
+            dll_func[2] == 0x90 && dll_func[3] == 0x90)
+        {
+            todo_wine ok(0, "%s: Export is a stub-function, skipping\n", func_name);
+            continue;
+        }
+
+        /* check position in memory */
+        dll_rva = (DWORD_PTR)dll_func - (DWORD_PTR)module;
+        map_rva = funcs[ordinals[i]];
+        ok(map_rva == dll_rva, "%s: Rva of mapped function (0x%x) does not match dll (0x%x)\n",
+           func_name, dll_rva, map_rva);
+
+        /* check position in file */
+        map_offset = (DWORD_PTR)RtlImageRvaToVa(RtlImageNtHeader(ptr),    ptr,    map_rva, NULL) - (DWORD_PTR)ptr;
+        dll_offset = (DWORD_PTR)RtlImageRvaToVa(RtlImageNtHeader(module), module, dll_rva, NULL) - (DWORD_PTR)module;
+        ok(map_offset == dll_offset, "%s: File offset of mapped function (0x%x) does not match dll (0x%x)\n",
+           func_name, map_offset, dll_offset);
+
+        /* check function content */
+        map_func = RVAToAddr(map_rva, ptr);
+        ok(!memcmp(map_func, dll_func, 0x20), "%s: Function content does not match!\n", func_name);
+
+        if (!strcmp(func_name, "NtSetEvent"))
+            pNtSetEvent = (void *)map_func;
+    }
+
+    ok(pNtSetEvent != NULL, "Could not find NtSetEvent export\n");
+    if (pNtSetEvent)
+    {
+        event = CreateEventA(NULL, TRUE, FALSE, NULL);
+        ok(event != NULL, "CreateEvent failed with error %u\n", GetLastError());
+        pNtSetEvent(event, 0);
+        ok(WaitForSingleObject(event, 0) == WAIT_OBJECT_0, "Event was not signaled\n");
+        CloseHandle(event);
+    }
+
+done:
+    UnmapViewOfFile(ptr);
+    CloseHandle(map);
+    CloseHandle(file);
+#endif
+}
+
 /* Verify linking style of import descriptors */
 static void test_ImportDescriptors(void)
 {
@@ -4033,6 +4123,7 @@ START_TEST(loader)
         return;
     }
 
+    test_FakeDLL();
     test_filenames();
     test_ResolveDelayLoadedAPI();
     test_ImportDescriptors();
-- 
2.27.0

>From 5673bd9a6161e54d368a138eeef9897d882eed4a Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Fri, 12 Jun 2020 01:28:41 +0200
Subject: [PATCH 02/32] winebuild: Export __wine_spec_module symbol.

So we can use NT header ImageBase for RVAs.
---
 dlls/ntdll/loader.c      |  8 +++++---
 dlls/ntdll/unix/loader.c |  4 ++--
 tools/winebuild/spec32.c | 13 ++++++++-----
 3 files changed, 15 insertions(+), 10 deletions(-)

diff --git a/dlls/ntdll/loader.c b/dlls/ntdll/loader.c
index 45d32399adf..506b9f099ba 100644
--- a/dlls/ntdll/loader.c
+++ b/dlls/ntdll/loader.c
@@ -2652,6 +2652,7 @@ static NTSTATUS load_so_dll( LPCWSTR load_path, const UNICODE_STRING *nt_name,
     struct builtin_load_info info, *prev_info;
     ANSI_STRING unix_name;
     UNICODE_STRING win_name = *nt_name;
+    HMODULE module;
 
     unix_name.Buffer = NULL;
     info.load_path = load_path;
@@ -2694,9 +2695,9 @@ static NTSTATUS load_so_dll( LPCWSTR load_path, const UNICODE_STRING *nt_name,
 
     if (info.status != STATUS_SUCCESS) goto failed;
 
-    if (!info.wm && (nt = dlsym( handle, "__wine_spec_nt_header" )))
+    if (!info.wm && (nt = dlsym( handle, "__wine_spec_nt_header" )) && (module = dlsym( handle, "__wine_spec_module" )))
     {
-        HMODULE module = (HMODULE)((nt->OptionalHeader.ImageBase + 0xffff) & ~0xffff);
+        module = (HMODULE)(((UINT_PTR)module + 0xffff) & ~0xffff);
         if ((info.wm = get_modref( module )))  /* already loaded */
         {
             TRACE( "Found %s at %p for builtin %s\n",
@@ -4355,6 +4356,7 @@ static NTSTATUS load_ntdll_so( HMODULE module, const IMAGE_NT_HEADERS *nt )
  */
 void __wine_process_init(void)
 {
+    extern BYTE __wine_spec_module;
     extern IMAGE_NT_HEADERS __wine_spec_nt_header;
     static const WCHAR ntdllW[] = {'\\','?','?','\\','C',':','\\','w','i','n','d','o','w','s','\\',
                                    's','y','s','t','e','m','3','2','\\',
@@ -4367,7 +4369,7 @@ void __wine_process_init(void)
     NTSTATUS status;
     ANSI_STRING func_name;
     UNICODE_STRING nt_name;
-    HMODULE ntdll_module = (HMODULE)((__wine_spec_nt_header.OptionalHeader.ImageBase + 0xffff) & ~0xffff);
+    HMODULE ntdll_module = (HMODULE)(((UINT_PTR)&__wine_spec_module + 0xffff) & ~0xffff);
     INITIAL_TEB stack;
     BOOL suspend;
     SIZE_T info_size;
diff --git a/dlls/ntdll/unix/loader.c b/dlls/ntdll/unix/loader.c
index b5ee692024c..b2e3fc2cc9f 100644
--- a/dlls/ntdll/unix/loader.c
+++ b/dlls/ntdll/unix/loader.c
@@ -968,11 +968,11 @@ static HMODULE load_ntdll(void)
     strcpy( name, info.dli_fname );
     strcpy( name + strlen(info.dli_fname) - 3, ".dll.so" );
     if (!(handle = dlopen( name, RTLD_NOW ))) fatal_error( "failed to load %s: %s\n", name, dlerror() );
-    if (!(nt = dlsym( handle, "__wine_spec_nt_header" )))
+    if (!(nt = dlsym( handle, "__wine_spec_nt_header" )) || !(module = dlsym( handle, "__wine_spec_module" )))
         fatal_error( "NT header not found in %s (too old?)\n", name );
     dll_dir = realpath_dirname( name );
     free( name );
-    module = (HMODULE)((nt->OptionalHeader.ImageBase + 0xffff) & ~0xffff);
+    module = (HMODULE)(((UINT_PTR)module + 0xffff) & ~0xffff);
     map_so_dll( nt, module );
     return module;
 }
diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index b1e20e0484d..7403ebdf2c6 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -607,12 +607,14 @@ void output_module( DLLSPEC *spec )
     case PLATFORM_APPLE:
         output( "\t.text\n" );
         output( "\t.align %d\n", get_alignment(page_size) );
-        output( "__wine_spec_pe_header:\n" );
+        output( "\t.globl %s\n", asm_name("__wine_spec_module") );
+        output( "%s:\n", asm_name("__wine_spec_module") );
         output( "\t.space 65536\n" );
         break;
     case PLATFORM_SOLARIS:
         output( "\n\t.section \".text\",\"ax\"\n" );
-        output( "__wine_spec_pe_header:\n" );
+        output( "\t.globl %s\n", asm_name("__wine_spec_module") );
+        output( "%s:\n", asm_name("__wine_spec_module") );
         output( "\t.skip %u\n", 65536 + page_size );
         break;
     default:
@@ -633,7 +635,8 @@ void output_module( DLLSPEC *spec )
             output( "\tb 1f\n" );
             break;
         }
-        output( "__wine_spec_pe_header:\n" );
+        output( "\t.globl %s\n", asm_name("__wine_spec_module") );
+        output( "%s:\n", asm_name("__wine_spec_module") );
         output( "\t.skip %u\n", 65536 + page_size );
         output( "1:\n" );
         break;
@@ -681,8 +684,8 @@ void output_module( DLLSPEC *spec )
         output( "\t.long 0\n" );          /* BaseOfCode */
         output( "\t.long 0\n" );          /* BaseOfData */
     }
-    output( "\t%s __wine_spec_pe_header\n",         /* ImageBase */
-             get_asm_ptr_keyword() );
+    output( "\t%s %s\n",                  /* ImageBase */
+             get_asm_ptr_keyword(), asm_name("__wine_spec_module") );
     output( "\t.long %u\n", page_size );  /* SectionAlignment */
     output( "\t.long %u\n", page_size );  /* FileAlignment */
     output( "\t.short 1,0\n" );           /* Major/MinorOperatingSystemVersion */
-- 
2.27.0

>From c833b63b06242106dd7e2fbe41e7a8bcd27a3638 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Thu, 11 Jun 2020 22:14:34 +0200
Subject: [PATCH 03/32] winebuild: Output pre-generated DOS header.

---
 dlls/ntdll/unix/loader.c | 19 +++++--------------
 tools/winebuild/spec32.c | 39 ++++++++++++++++++++++++++++++++++++---
 2 files changed, 41 insertions(+), 17 deletions(-)

diff --git a/dlls/ntdll/unix/loader.c b/dlls/ntdll/unix/loader.c
index b2e3fc2cc9f..58c7f7dda5a 100644
--- a/dlls/ntdll/unix/loader.c
+++ b/dlls/ntdll/unix/loader.c
@@ -737,23 +737,15 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
 
     if (wine_anon_mmap( addr, size, PROT_READ | PROT_WRITE, MAP_FIXED ) != addr) return STATUS_NO_MEMORY;
 
+    memmove(addr, (const BYTE *)nt_descr->OptionalHeader.ImageBase, size);
+
     dos = (IMAGE_DOS_HEADER *)addr;
-    nt  = (IMAGE_NT_HEADERS *)((BYTE *)(dos + 1) + sizeof(builtin_signature));
+    nt  = (IMAGE_NT_HEADERS *)((BYTE *)dos + dos->e_lfanew);
     sec = (IMAGE_SECTION_HEADER *)(nt + 1);
 
-    /* build the DOS and NT headers */
-
-    dos->e_magic    = IMAGE_DOS_SIGNATURE;
-    dos->e_cblp     = 0x90;
-    dos->e_cp       = 3;
-    dos->e_cparhdr  = (sizeof(*dos) + 0xf) / 0x10;
-    dos->e_minalloc = 0;
-    dos->e_maxalloc = 0xffff;
-    dos->e_ss       = 0x0000;
-    dos->e_sp       = 0x00b8;
-    dos->e_lfanew   = sizeof(*dos) + sizeof(builtin_signature);
+    /* build the NT headers */
 
-    *nt = *nt_descr;
+    nt->OptionalHeader.ImageBase = (ULONG_PTR)addr;
 
     delta      = (const BYTE *)nt_descr - addr;
     align_mask = nt->OptionalHeader.SectionAlignment - 1;
@@ -784,7 +776,6 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
     nt->OptionalHeader.SizeOfInitializedData       = data_end - data_start;
     nt->OptionalHeader.SizeOfUninitializedData     = 0;
     nt->OptionalHeader.SizeOfImage                 = data_end;
-    nt->OptionalHeader.ImageBase                   = (ULONG_PTR)addr;
 
     /* build the code section */
 
diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index 7403ebdf2c6..7a5f6f9c3cf 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -642,10 +642,43 @@ void output_module( DLLSPEC *spec )
         break;
     }
 
-    /* Output the NT header */
+    /* Output the DOS header */
 
     output( "\n\t.data\n" );
     output( "\t.align %d\n", get_alignment(get_ptr_size()) );
+    output( ".L__wine_spec_dos:\n" );
+    output( "\t.short 0x5a4d\n" );       /* e_magic */
+    output( "\t.short 0x90\n" );         /* e_cblp */
+    output( "\t.short 3\n" );            /* e_cp */
+    output( "\t.short 0\n" );            /* e_crlc */
+    output( "\t.short (%s-%s) / 16\n",   /* e_cparhdr */
+            asm_name("__wine_spec_nt_header"), ".L__wine_spec_dos" );
+    output( "\t.short 0x0000\n" );       /* e_minalloc */
+    output( "\t.short 0xffff\n" );       /* e_maxalloc */
+    output( "\t.short 0x0000\n" );       /* e_ss */
+    output( "\t.short 0x00b8\n" );       /* e_sp */
+    output( "\t.short 0\n" );            /* e_csum */
+    output( "\t.short 0\n" );            /* e_ip */
+    output( "\t.short 0\n" );            /* e_cs */
+    output( "\t.short %s-%s\n",          /* e_lfarlc */
+            asm_name("__wine_spec_nt_header"), ".L__wine_spec_dos" );
+    output( "\t.short 0\n" );            /* e_ovno */
+    output( "\t.long 0\n" );             /* e_res */
+    output( "\t.long 0\n" );
+    output( "\t.short 0\n" );            /* e_oemid */
+    output( "\t.short 0\n" );            /* e_oeminfo */
+    output( "\t.long 0\n" );             /* e_res2 */
+    output( "\t.long 0\n" );
+    output( "\t.long 0\n" );
+    output( "\t.long 0\n" );
+    output( "\t.long 0\n" );
+    output( "\t.long %s-%s\n",          /* e_lfanew */
+            asm_name("__wine_spec_nt_header"), ".L__wine_spec_dos" );
+    output( "\t.ascii \"Wine placeholder DLL\"\n" );
+
+    /* Output the NT header */
+
+    output( "\t.align 128, 0\n" );
     output( "\t.globl %s\n", asm_name("__wine_spec_nt_header") );
     output( "%s:\n", asm_name("__wine_spec_nt_header") );
     output( ".L__wine_spec_rva_base:\n" );
@@ -684,8 +717,8 @@ void output_module( DLLSPEC *spec )
         output( "\t.long 0\n" );          /* BaseOfCode */
         output( "\t.long 0\n" );          /* BaseOfData */
     }
-    output( "\t%s %s\n",                  /* ImageBase */
-             get_asm_ptr_keyword(), asm_name("__wine_spec_module") );
+    output( "\t%s .L__wine_spec_dos\n",   /* ImageBase */
+             get_asm_ptr_keyword() );
     output( "\t.long %u\n", page_size );  /* SectionAlignment */
     output( "\t.long %u\n", page_size );  /* FileAlignment */
     output( "\t.short 1,0\n" );           /* Major/MinorOperatingSystemVersion */
-- 
2.27.0

>From f066e10bf85e4449d5bb4772bddcae756f67abd3 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Wed, 10 Jun 2020 19:38:14 +0200
Subject: [PATCH 04/32] winebuild: Compute RVAs relative to DOS header.

Instead of incorrectly using NT header origin.
---
 dlls/ntdll/unix/loader.c | 5 +++--
 tools/winebuild/import.c | 2 +-
 tools/winebuild/spec32.c | 1 -
 tools/winebuild/utils.c  | 2 +-
 4 files changed, 5 insertions(+), 5 deletions(-)

diff --git a/dlls/ntdll/unix/loader.c b/dlls/ntdll/unix/loader.c
index 58c7f7dda5a..3ef3f90c612 100644
--- a/dlls/ntdll/unix/loader.c
+++ b/dlls/ntdll/unix/loader.c
@@ -117,7 +117,7 @@ static CPTABLEINFO unix_table;
 
 static inline void *get_rva( const IMAGE_NT_HEADERS *nt, ULONG_PTR addr )
 {
-    return (BYTE *)nt + addr;
+    return (BYTE *)nt->OptionalHeader.ImageBase + addr;
 }
 
 /* adjust an array of pointers to make them into RVAs */
@@ -735,6 +735,8 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
                   + sizeof(IMAGE_NT_HEADERS)
                   + nb_sections * sizeof(IMAGE_SECTION_HEADER));
 
+    delta = (const BYTE *)nt_descr->OptionalHeader.ImageBase - addr;
+
     if (wine_anon_mmap( addr, size, PROT_READ | PROT_WRITE, MAP_FIXED ) != addr) return STATUS_NO_MEMORY;
 
     memmove(addr, (const BYTE *)nt_descr->OptionalHeader.ImageBase, size);
@@ -747,7 +749,6 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
 
     nt->OptionalHeader.ImageBase = (ULONG_PTR)addr;
 
-    delta      = (const BYTE *)nt_descr - addr;
     align_mask = nt->OptionalHeader.SectionAlignment - 1;
     code_start = (size + align_mask) & ~align_mask;
     data_start = delta & ~align_mask;
diff --git a/tools/winebuild/import.c b/tools/winebuild/import.c
index 04ab433dd65..0719025bee9 100644
--- a/tools/winebuild/import.c
+++ b/tools/winebuild/import.c
@@ -834,7 +834,7 @@ static void output_immediate_imports(void)
                     else if (func->export_name) output( "__imp_%s:\n", asm_name( func->export_name ));
                 }
                 if (func->name)
-                    output( "\t%s .L__wine_spec_import_data_%s_%s-.L__wine_spec_rva_base\n",
+                    output( "\t%s .L__wine_spec_import_data_%s_%s-.L__wine_spec_dos\n",
                             get_asm_ptr_keyword(), import->c_name, func->name );
                 else
                 {
diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index 7a5f6f9c3cf..ff8762e450c 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -681,7 +681,6 @@ void output_module( DLLSPEC *spec )
     output( "\t.align 128, 0\n" );
     output( "\t.globl %s\n", asm_name("__wine_spec_nt_header") );
     output( "%s:\n", asm_name("__wine_spec_nt_header") );
-    output( ".L__wine_spec_rva_base:\n" );
 
     output( "\t.long 0x4550\n" );         /* Signature */
     switch(target_cpu)
diff --git a/tools/winebuild/utils.c b/tools/winebuild/utils.c
index 2a1fc960926..efc0637ba8a 100644
--- a/tools/winebuild/utils.c
+++ b/tools/winebuild/utils.c
@@ -1165,7 +1165,7 @@ void output_rva( const char *format, ... )
     default:
         output( "\t.long " );
         vfprintf( output_file, format, valist );
-        output( " - .L__wine_spec_rva_base\n" );
+        output( " - .L__wine_spec_dos\n" );
         break;
     }
     va_end( valist );
-- 
2.27.0

>From 5fa4bd89ab5e90e2ee57ac02b552eef0d3fb6040 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Wed, 10 Jun 2020 20:52:05 +0200
Subject: [PATCH 05/32] winebuild: Use RVAs in the export function pointers.

---
 dlls/ntdll/unix/loader.c |  2 +-
 tools/winebuild/spec32.c | 16 +++++++---------
 2 files changed, 8 insertions(+), 10 deletions(-)

diff --git a/dlls/ntdll/unix/loader.c b/dlls/ntdll/unix/loader.c
index 3ef3f90c612..99673144b00 100644
--- a/dlls/ntdll/unix/loader.c
+++ b/dlls/ntdll/unix/loader.c
@@ -843,7 +843,7 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
         fixup_rva_dwords( &exports->AddressOfNames, delta, 1 );
         fixup_rva_dwords( &exports->AddressOfNameOrdinals, delta, 1 );
         fixup_rva_dwords( (DWORD *)(addr + exports->AddressOfNames), delta, exports->NumberOfNames );
-        fixup_rva_ptrs( addr + exports->AddressOfFunctions, addr, exports->NumberOfFunctions );
+        fixup_rva_dwords( (DWORD *)(addr + exports->AddressOfFunctions), delta, exports->NumberOfFunctions );
     }
     return STATUS_SUCCESS;
 }
diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index ff8762e450c..15a645e9607 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -385,7 +385,6 @@ void output_exports( DLLSPEC *spec )
     int needs_imports = 0;
     int needs_relay = has_relays( spec );
     int nr_exports = spec->base <= spec->limit ? spec->limit - spec->base + 1 : 0;
-    const char *func_ptr = (target_platform == PLATFORM_WINDOWS) ? ".rva" : get_asm_ptr_keyword();
     const char *name;
 
     if (!nr_exports) return;
@@ -422,8 +421,7 @@ void output_exports( DLLSPEC *spec )
     for (i = spec->base; i <= spec->limit; i++)
     {
         ORDDEF *odp = spec->ordinals[i];
-        if (!odp) output( "\t%s 0\n",
-                          (target_platform == PLATFORM_WINDOWS) ? ".long" : get_asm_ptr_keyword() );
+        if (!odp) output( "\t.long 0\n" );
         else switch(odp->type)
         {
         case TYPE_EXTERN:
@@ -432,27 +430,27 @@ void output_exports( DLLSPEC *spec )
         case TYPE_CDECL:
             if (odp->flags & FLAG_FORWARD)
             {
-                output( "\t%s .L__wine_spec_forwards+%u\n", func_ptr, fwd_size );
+                output_rva( ".L__wine_spec_forwards+%u", fwd_size );
                 fwd_size += strlen(odp->link_name) + 1;
             }
             else if ((odp->flags & FLAG_IMPORT) && (target_cpu == CPU_x86 || target_cpu == CPU_x86_64))
             {
                 name = odp->name ? odp->name : odp->export_name;
-                if (name) output( "\t%s %s_%s\n", func_ptr, asm_name("__wine_spec_imp"), name );
-                else output( "\t%s %s_%u\n", func_ptr, asm_name("__wine_spec_imp"), i );
+                if (name) output_rva( "%s_%s", asm_name("__wine_spec_imp"), name );
+                else output_rva( "%s_%u", asm_name("__wine_spec_imp"), i );
                 needs_imports = 1;
             }
             else if (odp->flags & FLAG_EXT_LINK)
             {
-                output( "\t%s %s_%s\n", func_ptr, asm_name("__wine_spec_ext_link"), odp->link_name );
+                output_rva( "%s_%s", asm_name("__wine_spec_ext_link"), odp->link_name );
             }
             else
             {
-                output( "\t%s %s\n", func_ptr, asm_name( get_link_name( odp )));
+                output_rva( "%s", asm_name( get_link_name( odp )));
             }
             break;
         case TYPE_STUB:
-            output( "\t%s %s\n", func_ptr, asm_name( get_stub_name( odp, spec )) );
+            output_rva( "%s", asm_name( get_stub_name( odp, spec )) );
             break;
         default:
             assert(0);
-- 
2.27.0

>From be517bef80b74baf0591769ae4356fe51ba29626 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Thu, 11 Jun 2020 22:41:17 +0200
Subject: [PATCH 06/32] winebuild: Output NT header SizeOfHeaders field.

---
 dlls/ntdll/unix/loader.c | 10 +++-------
 tools/winebuild/spec32.c |  5 ++++-
 2 files changed, 7 insertions(+), 8 deletions(-)

diff --git a/dlls/ntdll/unix/loader.c b/dlls/ntdll/unix/loader.c
index 99673144b00..6e45dd99c25 100644
--- a/dlls/ntdll/unix/loader.c
+++ b/dlls/ntdll/unix/loader.c
@@ -721,19 +721,15 @@ void start_server( BOOL debug )
  */
 static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE module )
 {
-    static const char builtin_signature[32] = "Wine builtin DLL";
     IMAGE_DATA_DIRECTORY *dir;
     IMAGE_DOS_HEADER *dos;
     IMAGE_NT_HEADERS *nt;
     IMAGE_SECTION_HEADER *sec;
     BYTE *addr = (BYTE *)module;
     DWORD code_start, code_end, data_start, data_end, align_mask;
-    int delta, nb_sections = 2;  /* code + data */
+    int delta;
     unsigned int i;
-    DWORD size = (sizeof(IMAGE_DOS_HEADER)
-                  + sizeof(builtin_signature)
-                  + sizeof(IMAGE_NT_HEADERS)
-                  + nb_sections * sizeof(IMAGE_SECTION_HEADER));
+    DWORD size = nt_descr->OptionalHeader.SizeOfHeaders;
 
     delta = (const BYTE *)nt_descr->OptionalHeader.ImageBase - addr;
 
@@ -768,7 +764,7 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
 
     fixup_rva_ptrs( &nt->OptionalHeader.AddressOfEntryPoint, addr, 1 );
 
-    nt->FileHeader.NumberOfSections                = nb_sections;
+    nt->FileHeader.NumberOfSections                = 2;
     nt->OptionalHeader.BaseOfCode                  = code_start;
 #ifndef _WIN64
     nt->OptionalHeader.BaseOfData                  = data_start;
diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index 15a645e9607..9b58790f694 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -724,7 +724,7 @@ void output_module( DLLSPEC *spec )
              spec->subsystem_major, spec->subsystem_minor );
     output( "\t.long 0\n" );                          /* Win32VersionValue */
     output_rva( "%s", asm_name("_end") ); /* SizeOfImage */
-    output( "\t.long %u\n", page_size );  /* SizeOfHeaders */
+    output_rva( ".L__wine_spec_pe_end" ); /* SizeOfHeaders */
     output( "\t.long 0\n" );              /* CheckSum */
     output( "\t.short 0x%04x\n",          /* Subsystem */
              spec->subsystem );
@@ -746,6 +746,9 @@ void output_module( DLLSPEC *spec )
 
     output_data_directories( data_dirs );
 
+    output( "\t.align %u, 0\n", page_size );
+    output( "\t.L__wine_spec_pe_end:\n" );
+
     if (target_platform == PLATFORM_APPLE)
         output( "\t.lcomm %s,4\n", asm_name("_end") );
 }
-- 
2.27.0

>From bf744ecad9421d969f591e61038ee9ff8cdae2aa Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Thu, 11 Jun 2020 21:14:10 +0200
Subject: [PATCH 07/32] ntdll: Keep and fixup pre-existing sections headers.

---
 dlls/ntdll/unix/loader.c | 12 +++++++++++-
 1 file changed, 11 insertions(+), 1 deletion(-)

diff --git a/dlls/ntdll/unix/loader.c b/dlls/ntdll/unix/loader.c
index 6e45dd99c25..a9c52db2fa7 100644
--- a/dlls/ntdll/unix/loader.c
+++ b/dlls/ntdll/unix/loader.c
@@ -741,6 +741,15 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
     nt  = (IMAGE_NT_HEADERS *)((BYTE *)dos + dos->e_lfanew);
     sec = (IMAGE_SECTION_HEADER *)(nt + 1);
 
+    /* fixup the sections */
+
+    for (i = 0; i < nt->FileHeader.NumberOfSections; ++i)
+    {
+        fixup_rva_dwords( &sec[i].VirtualAddress, delta, 1 );
+        fixup_rva_dwords( &sec[i].PointerToRawData, delta, 1 );
+    }
+    sec = sec + nt->FileHeader.NumberOfSections;
+
     /* build the NT headers */
 
     nt->OptionalHeader.ImageBase = (ULONG_PTR)addr;
@@ -764,7 +773,6 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
 
     fixup_rva_ptrs( &nt->OptionalHeader.AddressOfEntryPoint, addr, 1 );
 
-    nt->FileHeader.NumberOfSections                = 2;
     nt->OptionalHeader.BaseOfCode                  = code_start;
 #ifndef _WIN64
     nt->OptionalHeader.BaseOfData                  = data_start;
@@ -782,6 +790,7 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
     sec->VirtualAddress   = code_start;
     sec->PointerToRawData = code_start;
     sec->Characteristics  = (IMAGE_SCN_CNT_CODE | IMAGE_SCN_MEM_EXECUTE | IMAGE_SCN_MEM_READ);
+    nt->FileHeader.NumberOfSections++;
     sec++;
 
     /* build the data section */
@@ -793,6 +802,7 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
     sec->PointerToRawData = data_start;
     sec->Characteristics  = (IMAGE_SCN_CNT_INITIALIZED_DATA |
                              IMAGE_SCN_MEM_WRITE | IMAGE_SCN_MEM_READ);
+    nt->FileHeader.NumberOfSections++;
     sec++;
 
     for (i = 0; i < nt->OptionalHeader.NumberOfRvaAndSizes; i++)
-- 
2.27.0

>From a19c1e37bd47d197695991336b69e24e3398d60c Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Fri, 12 Jun 2020 11:42:47 +0200
Subject: [PATCH 08/32] ntdll: Make writable PE section memory writable.

---
 dlls/ntdll/unix/loader.c | 37 +++++++++++++++++++++++++++++++++++++
 1 file changed, 37 insertions(+)

diff --git a/dlls/ntdll/unix/loader.c b/dlls/ntdll/unix/loader.c
index a9c52db2fa7..b313b5bf1ab 100644
--- a/dlls/ntdll/unix/loader.c
+++ b/dlls/ntdll/unix/loader.c
@@ -714,6 +714,35 @@ void start_server( BOOL debug )
 }
 
 
+/*************************************************************************
+ *      remap_writable
+ *
+ * Remap memory with write permissions, copying it if necessary.
+ */
+static NTSTATUS remap_writable( void *addr, size_t size )
+{
+    void *tmp;
+    int res;
+
+    if (!(res = mprotect( addr, size, PROT_READ | PROT_WRITE )))
+        return STATUS_SUCCESS;
+
+    if ((tmp = wine_anon_mmap( NULL, size, PROT_READ | PROT_WRITE, 0 )) == MAP_FAILED)
+        return STATUS_NO_MEMORY;
+    memcpy(tmp, addr, size);
+
+    if (wine_anon_mmap( addr, size, PROT_READ | PROT_WRITE, MAP_FIXED ) != addr)
+    {
+        munmap(tmp, size);
+        return STATUS_NO_MEMORY;
+    }
+
+    memcpy(addr, tmp, size);
+    munmap(tmp, size);
+    return STATUS_SUCCESS;
+}
+
+
 /*************************************************************************
  *		map_so_dll
  *
@@ -747,6 +776,10 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
     {
         fixup_rva_dwords( &sec[i].VirtualAddress, delta, 1 );
         fixup_rva_dwords( &sec[i].PointerToRawData, delta, 1 );
+
+        if ((sec[i].Characteristics & IMAGE_SCN_CNT_INITIALIZED_DATA) &&
+            remap_writable( addr + sec[i].VirtualAddress, sec[i].Misc.VirtualSize ))
+            return STATUS_NO_MEMORY;
     }
     sec = sec + nt->FileHeader.NumberOfSections;
 
@@ -911,10 +944,14 @@ static void fixup_ntdll_imports( const IMAGE_NT_HEADERS *nt, HMODULE ntdll_modul
     const IMAGE_IMPORT_DESCRIPTOR *descr;
     const IMAGE_THUNK_DATA *import_list;
     IMAGE_THUNK_DATA *thunk_list;
+    NTSTATUS status;
 
     assert( ntdll_exports );
 
     descr = get_rva( nt, nt->OptionalHeader.DataDirectory[IMAGE_FILE_IMPORT_DIRECTORY].VirtualAddress );
+    status = remap_writable( (void *)descr, nt->OptionalHeader.DataDirectory[IMAGE_FILE_IMPORT_DIRECTORY].Size );
+    assert(status == STATUS_SUCCESS);
+
     while (descr->Name)
     {
         /* ntdll must be the only import */
-- 
2.27.0

>From c0d4ebd299f1ee0b81579f07196ed58dd23c45ab Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Thu, 11 Jun 2020 21:35:55 +0200
Subject: [PATCH 09/32] winebuild: Use RVA for AddressOfEntryPoint.

---
 dlls/ntdll/unix/loader.c | 2 +-
 tools/winebuild/spec32.c | 9 +++------
 2 files changed, 4 insertions(+), 7 deletions(-)

diff --git a/dlls/ntdll/unix/loader.c b/dlls/ntdll/unix/loader.c
index b313b5bf1ab..ab2dab833e6 100644
--- a/dlls/ntdll/unix/loader.c
+++ b/dlls/ntdll/unix/loader.c
@@ -804,7 +804,7 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
     data_end   = (nt->OptionalHeader.SizeOfImage + delta + align_mask) & ~align_mask;
 #endif
 
-    fixup_rva_ptrs( &nt->OptionalHeader.AddressOfEntryPoint, addr, 1 );
+    fixup_rva_dwords( &nt->OptionalHeader.AddressOfEntryPoint, delta, 1 );
 
     nt->OptionalHeader.BaseOfCode                  = code_start;
 #ifndef _WIN64
